#include "cmogstored.h"
bool mog_cloexec_atomic;

/*
 * The presence of O_CLOEXEC in headers doesn't mean the kernel supports it
 */
#if defined(O_CLOEXEC) && (O_CLOEXEC != 0) && defined(SOCK_CLOEXEC)
__attribute__((constructor)) static
void mog_cloexec_detect(void)
{
	int flags;
	int fd = open("/dev/null", O_RDONLY|O_CLOEXEC);

	if (fd < 0) {
		if (errno == EINVAL) goto out;
		die("open(/dev/null) failed: %s", strerror(errno));
	}

	flags = fcntl(fd, F_GETFD);
	if (flags != -1)
		mog_cloexec_atomic = ((flags & FD_CLOEXEC) == FD_CLOEXEC);
	mog_close(fd);

	if (! mog_cloexec_atomic) goto out;

	/* try to ensure sockets are sane, too */
	fd = socket(AF_INET, SOCK_STREAM|SOCK_CLOEXEC, 0);
	if (fd < 0) {
		if (errno == EINVAL) goto out;
		die("socket(AF_INET, ...) failed: %s", strerror(errno));
	}
	flags = fcntl(fd, F_GETFD);
	if (flags != -1)
		mog_cloexec_atomic = ((flags & FD_CLOEXEC) == FD_CLOEXEC);
	mog_close(fd);

out:
	if (!mog_cloexec_atomic)
		warn("close-on-exec is NOT atomic\n");
}
#endif /* no O_CLOEXEC at all */
