
#line 1 "iostat_parser.rl"
/*
 * Copyright (C) 2012, Eric Wong <normalperson@yhbt.net>
 * License: GPLv3 or later (see COPYING for details)
 */
#include "cmogstored.h"


#line 39 "iostat_parser.rl"



#line 15 "iostat_parser.c"
static const int iostat_parser_start = 1;
static const int iostat_parser_first_final = 26;
static const int iostat_parser_error = 0;

static const int iostat_parser_en_ignored_line = 25;
static const int iostat_parser_en_main = 1;


#line 42 "iostat_parser.rl"

void mog_iostat_init(struct mog_iostat *iostat)
{
	int cs;
	struct mog_queue *queue = iostat->queue;

	memset(iostat, 0, sizeof(struct mog_iostat));
	
#line 33 "iostat_parser.c"
	{
	cs = iostat_parser_start;
	}

#line 50 "iostat_parser.rl"
	iostat->cs = cs;
	iostat->queue = queue;
}

enum mog_iostat_parser_state
mog_iostat_parse(struct mog_iostat *iostat, char *buf, size_t len)
{
	char *p, *pe, *eof = NULL;
	int cs = iostat->cs;
	size_t off = iostat->offset;

	assert(off <= len && "iostat offset past end of buffer");

	if (cs == iostat_parser_first_final)
		return MOG_IOSTAT_PARSER_DONE;

	p = buf + off;
	pe = buf + len;

	assert((void *)(pe - p) == (void *)(len - off) &&
	       "pointers aren't same distance");

	
#line 62 "iostat_parser.c"
	{
	if ( p == pe )
		goto _test_eof;
	switch ( cs )
	{
st1:
	if ( ++p == pe )
		goto _test_eof1;
case 1:
	if ( (*p) == 68 )
		goto st2;
	goto tr0;
tr0:
#line 38 "iostat_parser.rl"
	{ p--; {goto st25;} }
	goto st0;
#line 79 "iostat_parser.c"
st0:
cs = 0;
	goto _out;
st2:
	if ( ++p == pe )
		goto _test_eof2;
case 2:
	if ( (*p) == 101 )
		goto st3;
	goto tr0;
st3:
	if ( ++p == pe )
		goto _test_eof3;
case 3:
	if ( (*p) == 118 )
		goto st4;
	goto tr0;
st4:
	if ( ++p == pe )
		goto _test_eof4;
case 4:
	if ( (*p) == 105 )
		goto st5;
	goto tr0;
st5:
	if ( ++p == pe )
		goto _test_eof5;
case 5:
	if ( (*p) == 99 )
		goto st6;
	goto tr0;
st6:
	if ( ++p == pe )
		goto _test_eof6;
case 6:
	if ( (*p) == 101 )
		goto st7;
	goto tr0;
st7:
	if ( ++p == pe )
		goto _test_eof7;
case 7:
	if ( (*p) == 58 )
		goto st8;
	goto tr0;
st8:
	if ( ++p == pe )
		goto _test_eof8;
case 8:
	if ( (*p) == 10 )
		goto tr8;
	goto st8;
tr8:
#line 9 "iostat_parser.rl"
	{ iostat->line_end = p - buf; }
	goto st9;
st9:
	if ( ++p == pe )
		goto _test_eof9;
case 9:
#line 140 "iostat_parser.c"
	if ( (*p) == 32 )
		goto st9;
	if ( 9 <= (*p) && (*p) <= 13 )
		goto st9;
	goto tr9;
tr9:
#line 14 "iostat_parser.rl"
	{
				iostat->dev_tip = p - buf;
				iostat->dev_len = 0;
				iostat->util_tip = 0;
				iostat->util_len = 0;
			}
	goto st10;
st10:
	if ( ++p == pe )
		goto _test_eof10;
case 10:
#line 159 "iostat_parser.c"
	switch( (*p) ) {
		case 10: goto tr0;
		case 32: goto tr12;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto tr12;
	goto st10;
tr12:
#line 20 "iostat_parser.rl"
	{
				iostat->dev_len = p - buf - iostat->dev_tip;
			}
	goto st11;
st11:
	if ( ++p == pe )
		goto _test_eof11;
case 11:
#line 177 "iostat_parser.c"
	switch( (*p) ) {
		case 10: goto tr0;
		case 32: goto st12;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto st12;
	goto st11;
st12:
	if ( ++p == pe )
		goto _test_eof12;
case 12:
	switch( (*p) ) {
		case 10: goto tr0;
		case 32: goto st12;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto st12;
	goto tr15;
tr15:
#line 31 "iostat_parser.rl"
	{ iostat->util_tip = p - buf; }
	goto st13;
st13:
	if ( ++p == pe )
		goto _test_eof13;
case 13:
#line 204 "iostat_parser.c"
	switch( (*p) ) {
		case 10: goto tr17;
		case 32: goto st12;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto st12;
	goto st13;
tr17:
#line 32 "iostat_parser.rl"
	{
			iostat->util_len = p - buf - iostat->util_tip;
			mog_iostat_line_done(iostat, buf, len);
		}
#line 9 "iostat_parser.rl"
	{ iostat->line_end = p - buf; }
	goto st14;
tr31:
#line 9 "iostat_parser.rl"
	{ iostat->line_end = p - buf; }
#line 32 "iostat_parser.rl"
	{
			iostat->util_len = p - buf - iostat->util_tip;
			mog_iostat_line_done(iostat, buf, len);
		}
	goto st14;
st14:
	if ( ++p == pe )
		goto _test_eof14;
case 14:
#line 234 "iostat_parser.c"
	switch( (*p) ) {
		case 10: goto tr19;
		case 32: goto st14;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto st14;
	goto tr9;
tr19:
#line 9 "iostat_parser.rl"
	{ iostat->line_end = p - buf; }
#line 37 "iostat_parser.rl"
	{ mog_iostat_commit(); }
	goto st26;
st26:
	if ( ++p == pe )
		goto _test_eof26;
case 26:
#line 252 "iostat_parser.c"
	switch( (*p) ) {
		case 10: goto tr19;
		case 32: goto st14;
		case 68: goto tr34;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto st14;
	goto tr9;
tr34:
#line 14 "iostat_parser.rl"
	{
				iostat->dev_tip = p - buf;
				iostat->dev_len = 0;
				iostat->util_tip = 0;
				iostat->util_len = 0;
			}
	goto st15;
st15:
	if ( ++p == pe )
		goto _test_eof15;
case 15:
#line 274 "iostat_parser.c"
	switch( (*p) ) {
		case 10: goto tr0;
		case 32: goto tr12;
		case 101: goto st16;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto tr12;
	goto st10;
st16:
	if ( ++p == pe )
		goto _test_eof16;
case 16:
	switch( (*p) ) {
		case 10: goto tr0;
		case 32: goto tr12;
		case 118: goto st17;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto tr12;
	goto st10;
st17:
	if ( ++p == pe )
		goto _test_eof17;
case 17:
	switch( (*p) ) {
		case 10: goto tr0;
		case 32: goto tr12;
		case 105: goto st18;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto tr12;
	goto st10;
st18:
	if ( ++p == pe )
		goto _test_eof18;
case 18:
	switch( (*p) ) {
		case 10: goto tr0;
		case 32: goto tr12;
		case 99: goto st19;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto tr12;
	goto st10;
st19:
	if ( ++p == pe )
		goto _test_eof19;
case 19:
	switch( (*p) ) {
		case 10: goto tr0;
		case 32: goto tr12;
		case 101: goto st20;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto tr12;
	goto st10;
st20:
	if ( ++p == pe )
		goto _test_eof20;
case 20:
	switch( (*p) ) {
		case 10: goto tr0;
		case 32: goto tr12;
		case 58: goto st21;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto tr12;
	goto st10;
st21:
	if ( ++p == pe )
		goto _test_eof21;
case 21:
	switch( (*p) ) {
		case 10: goto tr8;
		case 32: goto tr26;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto tr26;
	goto st21;
tr26:
#line 20 "iostat_parser.rl"
	{
				iostat->dev_len = p - buf - iostat->dev_tip;
			}
	goto st22;
st22:
	if ( ++p == pe )
		goto _test_eof22;
case 22:
#line 364 "iostat_parser.c"
	switch( (*p) ) {
		case 10: goto tr8;
		case 32: goto st23;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto st23;
	goto st22;
st23:
	if ( ++p == pe )
		goto _test_eof23;
case 23:
	switch( (*p) ) {
		case 10: goto tr8;
		case 32: goto st23;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto st23;
	goto tr29;
tr29:
#line 31 "iostat_parser.rl"
	{ iostat->util_tip = p - buf; }
	goto st24;
st24:
	if ( ++p == pe )
		goto _test_eof24;
case 24:
#line 391 "iostat_parser.c"
	switch( (*p) ) {
		case 10: goto tr31;
		case 32: goto st23;
	}
	if ( 9 <= (*p) && (*p) <= 13 )
		goto st23;
	goto st24;
st25:
	if ( ++p == pe )
		goto _test_eof25;
case 25:
	if ( (*p) == 10 )
		goto tr33;
	goto st25;
tr33:
#line 9 "iostat_parser.rl"
	{ iostat->line_end = p - buf; }
#line 10 "iostat_parser.rl"
	{ {goto st1;} }
	goto st27;
st27:
	if ( ++p == pe )
		goto _test_eof27;
case 27:
#line 416 "iostat_parser.c"
	goto st0;
	}
	_test_eof1: cs = 1; goto _test_eof; 
	_test_eof2: cs = 2; goto _test_eof; 
	_test_eof3: cs = 3; goto _test_eof; 
	_test_eof4: cs = 4; goto _test_eof; 
	_test_eof5: cs = 5; goto _test_eof; 
	_test_eof6: cs = 6; goto _test_eof; 
	_test_eof7: cs = 7; goto _test_eof; 
	_test_eof8: cs = 8; goto _test_eof; 
	_test_eof9: cs = 9; goto _test_eof; 
	_test_eof10: cs = 10; goto _test_eof; 
	_test_eof11: cs = 11; goto _test_eof; 
	_test_eof12: cs = 12; goto _test_eof; 
	_test_eof13: cs = 13; goto _test_eof; 
	_test_eof14: cs = 14; goto _test_eof; 
	_test_eof26: cs = 26; goto _test_eof; 
	_test_eof15: cs = 15; goto _test_eof; 
	_test_eof16: cs = 16; goto _test_eof; 
	_test_eof17: cs = 17; goto _test_eof; 
	_test_eof18: cs = 18; goto _test_eof; 
	_test_eof19: cs = 19; goto _test_eof; 
	_test_eof20: cs = 20; goto _test_eof; 
	_test_eof21: cs = 21; goto _test_eof; 
	_test_eof22: cs = 22; goto _test_eof; 
	_test_eof23: cs = 23; goto _test_eof; 
	_test_eof24: cs = 24; goto _test_eof; 
	_test_eof25: cs = 25; goto _test_eof; 
	_test_eof27: cs = 27; goto _test_eof; 

	_test_eof: {}
	if ( p == eof )
	{
	switch ( cs ) {
	case 1: 
	case 2: 
	case 3: 
	case 4: 
	case 5: 
	case 6: 
	case 7: 
	case 8: 
	case 9: 
	case 10: 
	case 11: 
	case 12: 
	case 13: 
	case 14: 
	case 15: 
	case 16: 
	case 17: 
	case 18: 
	case 19: 
	case 20: 
	case 21: 
	case 22: 
	case 23: 
	case 24: 
#line 38 "iostat_parser.rl"
	{ p--; {goto st25;} }
	break;
#line 478 "iostat_parser.c"
	}
	}

	_out: {}
	}

#line 73 "iostat_parser.rl"

	iostat->cs = cs;
	iostat->offset = p - buf;

	if (cs == iostat_parser_error)
		return MOG_IOSTAT_PARSER_ERROR;

	assert(p <= pe && "buffer overflow after iostat parse");
	assert(iostat->offset <= len && "offset longer than len");

	if (cs == iostat_parser_first_final)
		return MOG_IOSTAT_PARSER_DONE;

	return MOG_IOSTAT_PARSER_WANTREAD;
}
