/*
 * Copyright (C) 2012, Eric Wong <normalperson@yhbt.net>
 * License: GPLv3 or later (see COPYING for details)
 */
#include "cmogstored.h"
/*
 * used only by queue_epoll.c, but should be usable with queue_kqueue.c
 * in the future
 */
MOG_NOINLINE static struct mog_queue *mog_queue_init(int queue_fd)
{
	struct mog_fd *mfd;
	struct mog_queue *q;

	CHECK(int, 0, set_cloexec_flag(queue_fd, true));

	mfd = mog_fd_get(queue_fd);
	mfd->fd_type = MOG_FD_TYPE_QUEUE;
	mfd->fd = queue_fd;
	q = &mfd->as.queue;
	q->queue_fd = queue_fd;
	SIMPLEQ_INIT(&q->activeq_head);
	CHECK(int, 0, pthread_mutex_init(&q->activeq_lock, NULL));
	memset(&q->thrpool, 0, sizeof(struct mog_thrpool));

	return q;
}
