# Copyright (C) 2012, Eric Wong <normalperson@yhbt.net>
# License: GPLv3 or later (see COPYING for details)

# This GNU makefile breaks down individual test/unit test cases from
# one .rb file and runs them individually (in parallel)

RUBY = ruby
TESTS := $(shell awk '/def test_/{print FILENAME"--"$$2".n"}' $(FILE))
all:: $(TESTS)
	@for i in $(subst /,+,$^); do \
		echo == $$i ==; \
		log=$(top_builddir)$$i.log; \
		cat $$log; \
		grep MOGFAIL $$log >/dev/null && MOGFAIL=1; \
		$(RM) $$log; \
	done; exit $$MOGFAIL

%.n: arg = $(subst .n,,$(subst --, -n ,$@))
%.n: log = $(top_builddir)$(subst /,+,$@).log
%.n:
	@$(RUBY) -w $(arg) -v >> $(log) 2>&1 || echo MOGFAIL=$$? >> $(log)
